var anonListCache;
var webCacheKey;
var userVitalStats;

function opac_init() {
	var advLink = getId("home_adv_search_link");
	if(advLink) advLink.setAttribute("href", buildOPACLink({page:ADVANCED})); 
	getId("home_myopac_link").setAttribute("href", buildOPACLink({page:MYOPAC}, false, true));
	getId("myopac_link").setAttribute("href", buildOPACLink({page:MYOPAC}, false, true));
	getOrgs();
	
  var u = grabUser();
  if(u) {
	unHideMe($('dash_wrapper'));
	  //alert(fetchOrgSettingDefault(G.user.home_ou(), 'auth.persistent_login_interval'));
	try {
	  var stats = fieldmapper.standardRequest(['open-ils.actor', 'open-ils.actor.user.opac.vital_stats'], {async:false, params:[u.session]});
	} catch(e){}
	userVitalStats = stats;
	if(!stats) return;
	
	var dashfines = $('dash_fines');
	if(stats.fines.balance_owed > 0) {
		dashfines.style.color = "#f41d36";
		dashfines.innerHTML = "$"+parseFloat(stats.fines.balance_owed).toFixed(2)
	} else {
		dashfines.style.fontWeight="normal";
		dashfines.innerHTML = "No";
	}
	$('dash_user').innerHTML = u.first_given_name()+' '+u.family_name();
	$('dash_checked').innerHTML = stats.checkouts.out+stats.checkouts.overdue;
	$('dash_holds').innerHTML = stats.holds.total;
	$('dash_pickup').innerHTML = stats.holds.ready;
  } else unHideMe($('your-acct-login'));
}

function mySuperInitFunction() {
	G.ui.common.now_searching = elem('div');
	webCacheKey = cookieManager.read('sessionID');
	var list = getCacheValue('anonListCache');
	anonListCache = isTrue(list)?list:[];
	if(anonListCache.length) try { unHideMe($('cacheListLink')); } catch(e){}
	
    /* overkill
	if(G.user && G.user.prefs[PREF_DEF_LOCATION]!="1") {
	  G.user.prefs[PREF_DEF_LOCATION]="1";
	  LOCATION = "1";
	  commitUserPrefs();
	  setSelector($('depth_selector'),	getLocation());
	  _newlocation = getLocation();
	}
    */
}

function setCacheValue(field, value, timeout) {
	if(!timeout) timeout = '30m';
	var key = fieldmapper.standardRequest(['open-ils.actor','open-ils.actor.anon_cache.set_value'],{async:false, params:[webCacheKey, field, value]});
	if(!isTrue(webCacheKey)) {
		webCacheKey = key;
		cookieManager.write('sessionID', webCacheKey, timeout);
	}
	return key;
}

function getCacheValue(field) {
	if(!isTrue(webCacheKey)) return null;
	var val = fieldmapper.standardRequest(['open-ils.actor','open-ils.actor.anon_cache.get_value'], {async:false, params:[webCacheKey, field]});
	return val;
}

function isInAnonList(id) {
	for(var i in anonListCache) {
		if(anonListCache[i] == id) return true;
	}	
	return false;
}

var isCacheListDrawn = false;
var anonListParent;
var anonListTemp;
function showCachedList() {
	if(grabUser()) goTo(buildOPACLink({page:MYOPAC, 'acctpage':6}, false, true));
	if(!anonListCache.length) {try { hideResultsPage(); } catch(e) {} hideMe($('anonListTable')); hideMe($('cacheListLink')); return;}
	try { hideResultsPage(true); } catch(e) {}
	unHideMe($('anonListTable'));
	if(!isCacheListDrawn) fieldmapper.standardRequest(["open-ils.search","open-ils.search.biblio.record.mods_slim.retrieve"],{async:true, params:[anonListCache], oncomplete:drawCacheList});	
}

function drawCacheList(r) {
	isCacheListDrawn = true;
	var bibs = r.recv().content();
	if(!anonListParent) anonListParent = $('anonListParent');
	if(!anonListTemp) anonListTemp = anonListParent.removeChild($('anonListTemp'));
	removeChildren(anonListParent);
	$('anon_selector').checked = false;
	
	if(grabUser()) {
		unHideMe($('holdsCacheSel'));
		setSelector($('holdsCacheSel'), grabUser().home_ou());
	}
	
	for(var i in bibs) {
		var row = anonListTemp.cloneNode(true);
		$n(row, 'anon_selector').doc_id = bibs[i].doc_id();
		$n(row, 'curr_row').innerHTML = parseInt(i)+1;
		$n(row, 'title').innerHTML = bibs[i].title();
		anonListParent.appendChild(row);
	}
}

function createBibHoldObject(org) {
	if(!G.user) return null;
	if(!org) org = G.user.home_ou();
	
	var node = findOrgUnit(org);
	var ntype = findOrgType(node.ou_type());
	if(!ntype.can_have_users()) return null;
	
	var hold = new ahr();
	var interval = fetchOrgSettingDefault(G.user.home_ou(), 'circ.hold_expire_interval');

	if(interval) {
	    var secs = interval_to_seconds(interval);
	    var expire = new Date();
	    expire.setTime(expire.getTime() + Number(secs + '000'));
	    var expireDate = holdsVerifyThawDate(dojo.date.stamp.toISOString(expire)); 
	    if(expireDate) hold.expire_time(expireDate);
    }

	hold.phone_notify("");
	hold.email_notify(0);
	hold.pickup_lib(org);
	hold.usr(G.user.id());
	hold.hold_type("T");
	hold.frozen('f');
	hold.thaw_date(null);
	
	return hold;
}

function batchHoldMyList(org, parent) {
	if(!grabUser()) return;
	if(!org) G.user.home_ou();
	if(!parent) parent = $('myopac_bookbag_div');
	
	var nodes = dojo.query('input[name=list_action_chbx]', parent).filter(function(node, index){ return node.checked; });
	if(!nodes.length) return;
	var arr = [];
	nodes.forEach(function(node, index){ arr.push(node.getAttribute("recordid")); });
	var error = {err:""};
	var resp = placeBatchHold(arr, org, error);
	if(resp == -1) alert("Unable to place holds"); else alert(resp+" hold"+(resp==1?"":"s")+" placed successfully\n\n"+error.err);

}

function placeBatchHold(ids, org, error) { // array of bib IDs, pickup lib (optional), error msgs from holds (optional)
	if(!grabUser() || !ids.length) return -1;
	if(!org) org = G.user.home_ou();

	var str = "";
	var flag = false;
    var success = -1;
    var errCount = 0;

    dojo.forEach(ids,
        function(target) {
            // first see if the hold is permitted
		    var hold = createBibHoldObject(org);
		    hold.target(target);
            var test = {titleid: hold.target(), hold_type: "T", patronid: G.user.id(), depth: 0, pickup_lib: org}

	        var resp = fieldmapper.standardRequest(
                ['open-ils.circ','open-ils.circ.title_hold.is_possible'], 
                {   async:false, 
                    params:[G.user.session, test]
                }
            );

            if(!resp.success) {
			    flag = true;
			    str += target + ": " + (resp.last_event.desc == "" ? resp.last_event.textcode:  resp.last_event.desc) + "\n";
                errCount++;
                return;
            }

            var resp2 = fieldmapper.standardRequest(
                ['open-ils.circ','open-ils.circ.holds.create'], 
                {   async:false, 
                    params:[grabUser().session, hold]
                }
            );

            if(typeof(resp2 == 'object')) {
                str += target + ": " + resp2[0].desc+"\n";
                errCount++;
            } else {
                success++;
            }

            if(str != "") error.err+=errCount+" holds not placed successfully\n"+str;
        }
    );

	if(str != "") error.err+=errCount+" hold"+(errCount==1?"":"s")+" not placed successfully\n"+str;
    return ++success;

    /*
    // Previous batch implementation, which doesn't work because the patron could exceed 
    // max holds during batch creation, after the initial permit test...

	var holds = [];
	var chkArr = [];
	for(var i=0; i<ids.length; i++) {
		holds[i] = createBibHoldObject(org);
		holds[i].target(ids[i]);
		chkArr.push({titleid: ids[i], volume_id: undefined, copy_id: undefined, hold_type: "T", patronid: G.user.id(), depth: 0, pickup_lib: org});
	}

	
	var resp = fieldmapper.standardRequest(['open-ils.circ','open-ils.circ.title_hold.is_possible.batch.atomic'], {async:false, params:[grabUser().session, chkArr]});
	
	var str = "";
	var errCount = 0;
	var flag = false;
	for(var n in resp) {
		if(!resp[n].success) {
			flag = true;
			str+=ids[n]+": "+(resp[n].last_event.desc==""?resp[n].last_event.textcode:resp[n].last_event.desc)+"\n";
			errCount++;
		}
	}
	
	if(str != "") error.err+=errCount+" hold"+(errCount==1?"":"s")+" not placed successfully\n"+str;
	if(flag) return 0;
	
	var resp2 = fieldmapper.standardRequest(['open-ils.circ','open-ils.circ.holds.create.batch.atomic'], {async:false, params:[grabUser().session, holds]});
	var count = -1;
	for(var t in resp2) {
		if(typeof(resp2[t]) != "object") count++; else {
			str+=ids[t]+": "+resp2[t][0].desc+"\n";
			errCount++;
		}
	}
	if(str != "") error.err+=errCount+" holds not placed successfully\n"+str;
	return ++count;
    */
}

function placeHoldOnCache() {
	//holdsDrawWindow(true);
	var holdsArr = [];
	dojo.query('input[name=anon_selector]',$('anonListParent')).filter(function(node, index){
		if(node.checked) holdsArr.push(node.doc_id+'');
	});
	
	if(!holdsArr.length) return;
	setCacheValue('saveAnonCache', holdsArr);
	goTo(buildOPACLink({page:MYOPAC}, false, true));
}

function delSelCache(parent, name) {
	if(!parent) parent = $('anonListParent');
	if(!name) name = 'anon_selector';
	anonListCache = [];
	var found = false;
	var nodes = dojo.query('input[name='+name+']',parent);
	if(!nodes.length) nodes = dojo.query('.'+name,parent);
	nodes.forEach(function(node, index){
		if(!node.checked) anonListCache.push(node.doc_id); else {
			found = true;
			var holdsLink = $n($('result_table_template_'+node.doc_id), 'result_my_list_link');
			if(holdsLink) {
				removeChildren(holdsLink);
				holdsLink.innerHTML = '';
				holdsLink.appendChild(elem('img', {src:'/opac/skin/kcls/graphics/add_mylist.gif'}, null));
				holdsLink.title = "Add to my list";
			}
		}
	});
	
	if(found) {
		isCacheListDrawn = false;
		setCacheValue('anonListCache', anonListCache);
		if(name=='anon_selector') showCachedList();
	}
}

String.prototype.trim = function() {
	return this.replace(/^\s+|\s+$/g,"");
}
String.prototype.ltrim = function() {
	return this.replace(/^\s+/,"");
}
String.prototype.rtrim = function() {
	return this.replace(/\s+$/,"");
}


//////////////////////
//Stephen Chapman
document.getElementsByClassName = function(cl) {
var retnode = [];
var myclass = new RegExp('\\b'+cl+'\\b');
var elems = document.getElementsByTagName('*');
for (var i = 0; i < elems.length; i++) {
var classes = elems[i].className;
if (myclass.test(classes)) retnode.push(elems[i]);
}
return retnode;
};

$c = document.getElementsByClassName;
////////////////////////////////////////////////////////////////////////

function getOrgs() {
  var tree = $('depth_selector');
  buildOrgSel(tree, globalOrgTree, 0);
  setSelector(tree, getLocation());
  //setSelector(tree, "1");
}

function swapTabs(el) {
  if(!el) return;
  var tabs = dojo.query("a",el.parentNode.id);
  for(var n=0; n< tabs.length;n++) {
	var i = tabs[n];
	if(i==el) {
	  unHideMe($(i.rel));
	  i.style.background="url('/opac/skin/kcls/graphics/"+i.id+"_on.gif') no-repeat bottom";
	} else {
	  hideMe($(i.rel));
	  i.style.background="url('/opac/skin/kcls/graphics/"+i.id+"_off.gif') no-repeat bottom";
	}
  }
}

// walk the marc record dom - returns a concatenated string of the requested marc subfields
// depth-first recursive function
function walkXML(xml,field,subfield) {
	if(!xml || !field || !subfield) return "";
	var nodes = (xml.childNodes)?xml.childNodes:null;
	if(!nodes) return "";
	var str = "";
	
	for(var i=0; i<nodes.length; i++) {
		var obj = nodes[i];
		if(obj.hasChildNodes()) {
			var tag = (obj.nodeName=="datafield")?obj.getAttribute("tag"):"";
			if(tag==field) {
			  for(var n=0; n<obj.childNodes.length; n++){
			    var child = obj.childNodes[n];
			    var code = (child.nodeName=="subfield")?child.getAttribute("code"):"";
			    if(code==subfield) str += (child.textContent)?child.textContent:child.text; // IE check
			  }
			}
			str += walkXML(obj,field,subfield);
		}
	}
	return str;
}

// returns the requested marc data or passes it to callback if present
// callback arg is optional
function getMarcData(docid, field, subfield, callback) {
	if(!docid || !field || !subfield) return "";
	var cgi = new CGI();
	var xhr = buildXMLRequest();
	var proto = (location.href.match(/^[Hh][Tt][Tt][Pp][Ss]:/))?"https://":"http://";
	
	if(typeof(callback)=="function") {
		xhr.onreadystatechange = function() {
				if(xhr.readyState==4 && xhr.status == 200) callback(walkXML(xhr.responseXML.documentElement,field.toLowerCase(),subfield.toLowerCase()), docid);
		}
	}
	
	xhr.open("GET",proto+cgi.server_name+"/opac/extras/supercat/retrieve/marcxml/record/"+docid,((callback)?true:false));
	xhr.send(null);
	
	if(typeof(callback)!="function" && xhr.status == 200) {
		return walkXML(xhr.responseXML.documentElement,field.toLowerCase(),subfield.toLowerCase());
	} else return "";
}

function setFormatIcon(imgEl, type) {
	if(!imgEl) return false;
	if(!type) { hideMe(imgEl); return false; }
	var img = "";
	
	switch(type.toLowerCase()) {
	  case "a": img="media_book.png"; break;
	  case "b": img="media_magazines.png"; break;
	  case "c": img="media_printedmusic.jpg"; break;
	  case "d": img="media_microform.jpg"; break;
	  case "e": img="media_equipment.png"; break;
	  case "f": img="media_films.png"; break;
	  case "g": img="media_films.png"; break;
	  case "h": img="media_dvd.jpg"; break;
	  case "i": img="media_bookoncassette.jpg"; break;
	  case "j": img="media_musiccd.png"; break;
	  case "k": img="media_musiccassette.jpg"; break;
	  case "l": img="media_musicrecord.jpg"; break;
	  case "m": img="media_software.jpg"; break;
	  case "n": img="media_bookoncd.png"; break;
	  case "o": img="media_kit.jpg"; break;
	  case "p": img="media_newspaper.jpg"; break;
	  case "q": img="media_largeprint.jpg"; break;
	  case "r": img="media_3dobject.jpg"; break;
	  case "s": img="media_slide.jpg"; break;
	  case "t": img="media_online.jpg"; break;
	  case "u": img="media_eaudio.jpg"; break;
	  case "v": img="media_ebooktext.png"; break;
	  case "w": img="media_eaudio.png"; break;
	  case "x": img="media_downloadmusic.png"; break;
	  case "y": img="media_downloadvideo.jpg"; break;
	  case "z": img="media_map.jpg"; break;
	  case "2": img="media_cassettewithbook.png"; break;
	  case "5": img="media_cdwithbook.png"; break;
	}
	
	if(img) {
		imgEl.title = get998dValue(type);
		dojo.attr(imgEl, "src","/opac/skin/kcls/graphics/"+img);
		dojo.attr(imgEl, "alt", get998dValue(type));
	} else { hideMe(imgEl); return false; }
	
	unHideMe(imgEl);
	return true;
}

function get998dValue(code) {
	if(!code) code = "";
	code = code.toLowerCase();
	var Label = "";
	
	switch(code) {
		case "a": Label = "Book"; break;
		case "i": Label = "Book on cassette"; break;
		case "n": Label = "Book on CD"; break;
		case "x": Label = "Download music"; break;
		case "y": Label = "Download video"; break;
		case "h": Label = "DVD"; break;
		case "w": Label = "eBook - Audio"; break;
		case "v": Label = "eBook - Text"; break;
		case "e": Label = "Equipment"; break;
		case "f": Label = "Films"; break;
		case "o": Label = "Kit"; break;
		case "q": Label = "Large print"; break;
		case "b": Label = "Magazine"; break;
		case "d": Label = "Microform"; break;
		case "k": Label = "Music cassette"; break;
		case "j": Label = "Music CD"; break;
		case "l": Label = "Music LP"; break;
		case "p": Label = "Newspaper"; break;
		case "t": Label = "Online"; break;
		case "u": Label = "Player"; break;
		case "c": Label = "Printed music"; break;
		case "2": Label = "Read along with cassette"; break;
		case "5": Label = "Read along with CD"; break;
		case "c": Label = "Scores"; break;
		case "m": Label = "Software"; break;
		case "g": Label = "Video"; break;
		case "r": Label = "3-D Object"; break;
		case "z": Label = "Map"; break;
		case "s": Label = "Slide set"; break;
	}
	return Label;
}

function mapLibUrl(lib) {
	var url = "";
	switch(lib) {
		case "1489": url = "http://www.kcls.org/algonapacific/"; break;
		case "1490": url = "http://www.kcls.org/auburn/"; break;
		case "1492": url = "http://www.kcls.org/bellevue/"; break;
		case "1491": url = "http://www.kcls.org/blackdiamond/"; break;
		case "1493": url = "http://www.kcls.org/bothell/"; break;
		case "1494": url = "http://www.kcls.org/boulevardpark/"; break;
		case "1495": url = "http://www.kcls.org/burien/"; break;
		case "1496": url = "http://www.kcls.org/carnation/"; break;
		case "1497": url = "http://www.kcls.org/covington/"; break;
		case "1502": url = "http://www.kcls.org/desmoines/"; break;
		case "1503": url = "http://www.kcls.org/duvall/"; break;
		case "1508": url = "http://www.kcls.org/fairwood/"; break;
		case "1506": url = "http://www.kcls.org/fallcity/"; break;
		case "1509": url = "http://www.kcls.org/federalway/"; break;
		case "1505": url = "http://www.kcls.org/320th/"; break;
		case "1507": url = "http://www.kcls.org/foster/"; break;
		case "1513": url = "http://www.kcls.org/issaquah/"; break;
		case "1519": url = "http://www.kcls.org/kenmore/"; break;
		case "1520": url = "http://www.kcls.org/kent/"; break;
		case "1517": url = "http://www.kcls.org/kingsgate/"; break;
		case "1518": url = "http://www.kcls.org/kirkland/"; break;
		case "1521": url = "http://www.kcls.org/lakeforestpark/"; break;
		case "1522": url = "http://www.kcls.org/lakehills/"; break;
		case "1499": url = "http://www.kcls.org/crossroads/"; break;
		case "1538": url = "http://www.kcls.org/southcenter/"; break;
		case "1527": url = "http://www.kcls.org/maplevalley/"; break;
		case "1525": url = "http://www.kcls.org/mercerisland/"; break;
		case "1526": url = "http://www.kcls.org/muckleshoot/"; break;
		case "1529": url = "http://www.kcls.org/newportway/"; break;
		case "1528": url = "http://www.kcls.org/northbend/"; break;
		case "1533": url = "http://www.kcls.org/redmond/"; break;
		case "1532": url = "http://www.kcls.org/richmondbeach/"; break;
		case "1534": url = "http://www.kcls.org/sammamish/"; break;
		case "1536": url = "http://www.kcls.org/skykomish/"; break;
		case "1541": url = "http://www.kcls.org/skyway/"; break;
		case "1537": url = "http://www.kcls.org/snoqualmie/"; break;
		case "1546": url = "http://www.kcls.org/valleyview/"; break;
		case "1545": url = "http://www.kcls.org/vashon/"; break;
		case "1547": url = "http://www.kcls.org/whitecenter/"; break;
		case "1548": url = "http://www.kcls.org/woodinville/"; break;
		case "1549": url = "http://www.kcls.org/woodmont/"; break;
		case "1535": url = "http://www.kcls.org/shoreline/"; break;
		case "1540": url = "http://www.kcls.org/servicecenter/"; break;
		case "1510": url = "http://www.kcls.org/greenbridge/"; break;
		//case "": url = "http://www.kcls.org/federalway/#closure"; break;
		case "1559": url = "http://www.kcls.org/libraryexpress/"; break;
		case "1556": url = "http://www.kcls.org/renton/"; break;
		case "1557": url = "http://www.kcls.org/rentonhighlands/"; break;
		default: url = "";
	}
	return url;
}

function checkAll(parent, id, name) {//Object, string
	var obj = typeof(id)=="object"?id:$(id);
	if(!parent || !obj) return;
	if(!name) name = id.toString();
	var nodes = dojo.query('input[name='+name+']', parent);
	if(!nodes.length) nodes = dojo.query('.'+name, parent);
	nodes.forEach(function(node, index){
		node.checked = obj.checked;
	});
}

var blinkMeArr = [];
function blinkMe(str,bool) {
	var obj = $(str);
	if(!obj) return;
	
	if(bool) {
		clearInterval(blinkMeArr[str]);
		hideMe(obj);
	} else blinkMeArr[str] = setInterval(function(){
		obj.blinker?hideMe(obj):unHideMe(obj);
		obj.blinker=!obj.blinker;}, 500);
}

// null out all children of parent obj
errCounter=0;
errCounter2=0;
function destroyObj(obj) {
	errCounter++;
	if(!obj) return;
	errCounter2++;
	for(var i in obj) {
		if(typeof(obj[i])=="function" && i=="destroyObj") continue;
		if(typeof(obj[i])=="object" && obj[i]!=null && typeof(obj[i].tagName)=="undefined") destroyObj(obj[i]);
		try { obj[i]=null; } catch(e){}
	}
	obj=null;
}

attachEvt("common","init",mySuperInitFunction);
